#Project: Varying Magnetic Field by Sean Cashin, MA198, 2013

from visual import *
from math import*
print("""
Click to place a test charge with the input velocity, mass, and charge.
Try to get through the loops.
""")
scene.title="test charge in a magnetic field"
scene.width = 1000
scene.height = 1000
scene.autoscale = 0
scene.range = (60, 40, 10)

#Goals
plane=curve(pos=[(-40,-10,0),(-40,10,0),(-20,10,0),(-20,-10,0),(-40,-10,0)])
plane=curve(pos=[(40,10,10),(40,10,-10),(40,-10,-10),(40,-10,10),(40,10,10)])

#Test Charge Initial Conditions
tg= sphere(pos=(scene.mouse.getclick().pos), color=color.red, radius=1, make_trail=True )#testcharge
#tg.velocity=vector(1,0,0)
#tg.charge= 1
#tg.mass=1

#Magnetic Field
f=vector(0,0,10)
dt=.01 #increment
t=1
pi=math.pi

#User input
tg.mass=input('Test Charge Mass? Try 1-10: ')
tg.charge=input('Test Charge? Try 1-5: ')
tg.velocity=vector(input('Initial x Velocity? Try 1-5: '),input ('Initial y velocity?: '),input ('Initial z velocity? :'))

while True:
    rate(100)
    tg.pos=tg.pos+tg.velocity*dt
    tg.velocity= tg.velocity+ dt*(cross(f,tg.velocity)*tg.charge)/(tg.mass)
    t+= dt #increases t incrementally by dt
    f=vector(0,0,(10/(1+tg.z)))
    #f=vector(0,0, 10*cos(2*pi*t))#variable magnetic field
    #if tg.x== 40: and tg.y<10 and tg.y>-10 and tg.z<10 and tg.z>-10:
        #tg.velocity=0
        #print "goal!"
